/*
    Created by Quo
*/
 


-- NOTE THAT THIS CODE ALWAYS RUNS FIRST


-- LOGS




-- Debug
INSERT INTO tblQuoDebug 
	(DebugID, 		x_Open, x_Close, 	Message)
VALUES ('Quo_Rules_Code',	'1',	'0',		'') ;





-- UNIT MOVEMENT (ROCKETBOOTS)
-- Give every unit 1 additional move point
UPDATE Units SET BaseMoves=BaseMoves + (SELECT tblQuoOptions.Value FROM tblQuoOptions WHERE OptionID='QUO_OPTION_ROCKETBOOTS') WHERE BaseMoves >= 2;



-- AI FREE SETTLERS
-- AI no longer gets free Settler at higher difficulties

DELETE FROM MajorStartingUnits WHERE Unit='UNIT_SETTLER' AND Era='ERA_ANCIENT' AND AiOnly=1 AND MinDifficulty='DIFFICULTY_EMPEROR' ;




-- GOVERNMENT

-- Chiefdom 
-- Remove the economic policy slot and add a wildcard slot
UPDATE Government_SlotCounts SET NumSlots=0 WHERE GovernmentType='GOVERNMENT_CHIEFDOM' AND GovernmentSlotType='SLOT_ECONOMIC' ;

INSERT INTO Government_SlotCounts 
		(GovernmentType, GovernmentSlotType, NumSlots)
VALUES 		('GOVERNMENT_CHIEFDOM', 'SLOT_WILDCARD', 1) ;






-- DISTRICTS

-- AQUEDUCT
-- Aqueducts/Baths provide Great Engineer points
INSERT INTO District_GreatPersonPoints 
	(DistrictType, 		GreatPersonClassType, 		PointsPerTurn)
VALUES	('DISTRICT_AQUEDUCT',	'GREAT_PERSON_CLASS_ENGINEER',	'1' ) ,
		('DISTRICT_BATH',	'GREAT_PERSON_CLASS_ENGINEER',	'2' ) ;




-- Note that PLOT_HAS_PLANTATION_TAG_REQUIREMENTS is changed in the setup code to apply to ALL planations, not just a subset
INSERT INTO Modifiers 
	(ModifierId, ModifierType, RunOnce, Permanent, OwnerRequirementSetId, SubjectRequirementSetId)
VALUES	('QUO_AQUEDUCT_FOOD', 'MODIFIER_CITY_PLOT_YIELDS_ADJUST_PLOT_YIELD', 0, 0, NULL, 'PLOT_HAS_PLANTATION_TAG_REQUIREMENTS') ;


INSERT INTO ModifierArguments
	(ModifierId, 			Name, 		Type, 			Value, 			Extra, 	SecondExtra)
VALUES	('QUO_AQUEDUCT_FOOD', 	'Amount', 	'ARGTYPE_IDENTITY', 		'2',			NULL, 	NULL),
	('QUO_AQUEDUCT_FOOD', 	'YieldType', 	'ARGTYPE_IDENTITY', 		'YIELD_FOOD',			NULL, 	NULL) ;


INSERT INTO DistrictModifiers
		(DistrictType, 			ModifierID)
VALUES	('DISTRICT_AQUEDUCT',	'QUO_AQUEDUCT_FOOD'),
		('DISTRICT_BATH',		'QUO_AQUEDUCT_FOOD') ; 


		
-- Make Aqueducts provide water radially to cities up to 6 tiles away
INSERT INTO Requirements
		(RequirementId, 		RequirementType, 	Likeliness,	Inverse, 	Triggered)
VALUES	('QUO_REQ_AQUEDUCT_RADIUS', 	'REQUIREMENT_PLOT_ADJACENT_DISTRICT_TYPE_MATCHES',	0,0,0) ,
		('QUO_REQ_BATH_RADIUS', 	'REQUIREMENT_PLOT_ADJACENT_DISTRICT_TYPE_MATCHES',	0,0,0) ;

INSERT INTO RequirementArguments 
		(RequirementId,			Name, 			Type, 			Value, 		Extra, 	SecondExtra)
VALUES 	('QUO_REQ_AQUEDUCT_RADIUS',	'DistrictType',		'ARGTYPE_IDENTITY',	'DISTRICT_AQUEDUCT',	NULL,	NULL 	)  ,
		('QUO_REQ_AQUEDUCT_RADIUS',	'MaxRange',		'ARGTYPE_IDENTITY',		'6',	NULL,	NULL 	) ,
		('QUO_REQ_AQUEDUCT_RADIUS',	'MinRange',		'ARGTYPE_IDENTITY',		'2',	NULL,	NULL 	) ,
		('QUO_REQ_BATH_RADIUS',	'DistrictType',		'ARGTYPE_IDENTITY',	'DISTRICT_BATH',	NULL,	NULL 	)  ,
		('QUO_REQ_BATH_RADIUS',	'MaxRange',		'ARGTYPE_IDENTITY',		'6',	NULL,	NULL 	) ,
		('QUO_REQ_BATH_RADIUS',	'MinRange',		'ARGTYPE_IDENTITY',		'2',	NULL,	NULL 	) ;

		
INSERT INTO RequirementSets 
		(RequirementSetId, 		RequirementSetType)
VALUES 	('QUO_REQSET_AQUEDUCT_RADIUS', 	'REQUIREMENTSET_TEST_ANY') ;

 INSERT INTO RequirementSetRequirements
	(RequirementSetId,	RequirementId)
VALUES	('QUO_REQSET_AQUEDUCT_RADIUS', 	'QUO_REQ_AQUEDUCT_RADIUS') ,
		('QUO_REQSET_AQUEDUCT_RADIUS', 	'QUO_REQ_BATH_RADIUS') ;
		

INSERT INTO Modifiers 
		(ModifierId, ModifierType, RunOnce, Permanent, OwnerRequirementSetId, SubjectRequirementSetId)
VALUES	('QUO_AQUEDUCT_RADIUS_MAJOR_CIV_ABILITY', 'MODIFIER_PLAYER_CITIES_ADJUST_WATER_HOUSING', 0, 0, NULL, 'QUO_REQSET_AQUEDUCT_RADIUS') ;
 
INSERT INTO ModifierArguments
		(ModifierId, 			Name, 		Type, 			Value, 			Extra, 	SecondExtra)
VALUES	('QUO_AQUEDUCT_RADIUS_MAJOR_CIV_ABILITY', 	'Amount', 	'ARGTYPE_IDENTITY', 	'3',			NULL, 	NULL)  ;

INSERT INTO TraitModifiers
		(TraitType, 			ModifierID)
VALUES	('TRAIT_LEADER_MAJOR_CIV',	'QUO_AQUEDUCT_RADIUS_MAJOR_CIV_ABILITY')  ;
 		
		
	


		
		
		
-- ENCAMPMENT
-- Unlocks very early. In v3.09 added a prereqCivic to prevent screamer from CQUI
UPDATE Districts SET PrereqTech=NULL, PrereqCivic='CIVIC_CODE_OF_LAWS' WHERE DistrictType='DISTRICT_ENCAMPMENT' ;



-- WALLS 
-- Walls require a Barracks or Stable
-- In v3.10.3 added as a MyOptions option
INSERT INTO BuildingPrereqs 
		(Building, PrereqBuilding)
SELECT	'BUILDING_WALLS', 'BUILDING_BARRACKS'
FROM tblQuoOptions 
WHERE OptionID='QUO_OPTION_WALLS_HAVE_PREREQS' AND Value >= 1 ;

INSERT INTO BuildingPrereqs 
		(Building, PrereqBuilding)
SELECT	'BUILDING_WALLS', 'BUILDING_STABLE'
FROM tblQuoOptions 
WHERE OptionID='QUO_OPTION_WALLS_HAVE_PREREQS' AND Value >= 1 ;






-- Move the stable and barracks up a tech
UPDATE Buildings SET PrereqTech='TECH_MINING' WHERE BuildingType='BUILDING_BARRACKS' ;
UPDATE Buildings SET PrereqTech='TECH_ANIMAL_HUSBANDRY', Cost='80' WHERE BuildingType='BUILDING_STABLE' ;


-- HOLY SITE
-- Move it off the tech tree to the civic tree, in the Mysticism civic
UPDATE Districts SET PrereqTech=NULL, PrereqCivic='CIVIC_MYSTICISM' WHERE DistrictType='DISTRICT_HOLY_SITE'; 
UPDATE Districts SET PrereqTech=NULL, PreReqCivic='CIVIC_MYSTICISM' WHERE DistrictType='DISTRICT_LAVRA' ;

-- Increase the number of GPP per turn to 3, because this mod makes getting prophets so much slower
UPDATE District_GreatPersonPoints SET PointsPerTurn='3' WHERE GreatPersonClassType='GREAT_PERSON_CLASS_PROPHET' AND DistrictType='DISTRICT_HOLY_SITE' ;
UPDATE District_GreatPersonPoints SET PointsPerTurn='4' WHERE GreatPersonClassType='GREAT_PERSON_CLASS_PROPHET' AND DistrictType='DISTRICT_LAVRA' ;



-- DISTRICT COST PROGRESSION MODEL
-- Coded out for now. For future release after fine tuning.

-- change progression model to increase based on number of previously built districts of this type
-- UPDATE Districts SET CostProgressionModel='COST_PROGRESSION_PREVIOUS_COPIES', CostProgressionParam1=20 ;

-- fix city centers
-- UPDATE Districts SET CostProgressionModel='NO_COST_PROGRESSION' WHERE DistrictType='DISTRICT_CITY_CENTER' ;



-- BUILDINGS

-- MONUMENTS
-- Because borders pop faster, the Monument is now a vital building. To balance with Rome, I cut the production cost of Monuments in half.
-- This is no longer necessary as of v3.11.6
-- UPDATE Buildings SET Cost=Cost*0.5 WHERE BuildingType='BUILDING_MONUMENT' ;	


--PALACE
--The Palace has the effect of walls
UPDATE Buildings SET OuterDefenseHitPoints='40', OuterDefenseStrength='2' WHERE BuildingType='BUILDING_PALACE' ;




-- SEWER
-- Now available at Mathematics, cost reduced
UPDATE Buildings SET PrereqTech='TECH_MATHEMATICS', Cost=Cost*0.5 WHERE BuildingType='BUILDING_SEWER' ;



-- REGIONAL BUILDINGS
-- Double yields of regional buildings
UPDATE Building_YieldChanges SET YieldChange=YieldChange *2 WHERE BuildingType='BUILDING_FACTORY' ;
UPDATE Building_YieldChanges SET YieldChange=YieldChange *2 WHERE BuildingType='BUILDING_ELECTRONICS_FACTORY' ;
UPDATE Building_YieldChanges SET YieldChange=YieldChange *2 WHERE BuildingType='BUILDING_POWER_PLANT' ;

UPDATE Buildings SET Entertainment='3' WHERE BuildingType='BUILDING_ZOO' ;





--- TECHS


-- ASTROLOGY
-- Changed in v3.06 to allow Scouts to embark at Celestial Navigation, Traders at Astrology
UPDATE Technologies SET EmbarkUnitType='UNIT_SCOUT' WHERE TechnologyType='TECH_CELESTIAL_NAVIGATION' ;
UPDATE Technologies SET EmbarkUnitType='UNIT_TRADER', Description='QUO_LOC_TECH_ASTROLOGY_DESCRIPTION' WHERE TechnologyType='TECH_ASTROLOGY' ;


UPDATE Technologies SET Description='QUO_LOC_TECH_WRITING_DESCRIPTION' WHERE TechnologyType='TECH_WRITING' ;


-- Increase the cost of the tech somewhat given all the changes made to it
UPDATE Technologies SET Cost='80' WHERE TechnologyType='TECH_ASTROLOGY' ;




-- UPDATE BUG TRACKER
-- This code should go last in every file

UPDATE tblQuoDebug SET x_Close='1' WHERE DebugID='Quo_Rules_Code';